\section{Background}
\subsection{Terminology}
Following the specifications in RFC 4949\cite{RFC4949}, we define the next concepts:
\begin{description}
	\item[Authorization:]{ An approval that is granted to a system entity to access a system resource.}
	\item[Authentication:]{The process of verifying a claim that a system entity or system resource has a certain attribute value.}
	\end{description}
These two terms lay the foundations of every cyber security protocol, given the fact that one is intertwined with the other. That is, one user can be authorized only if authenticate first, and one user being authenticate leads to having an authorized used.
\begin{description}
\item[Credential:]{ A data object
	that is a portable representation of the association between an
	identifier and a unit of authentication information, and that can
	be presented for use in verifying an identity claimed by an entity
	that attempts to access a system. Example: X.509 public-key
	certificate}
	\item[Confidentiality:]{property of preserving authorized restrictions on information access and disclosure,
		including means for protecting personal privacy and proprietary information}
	\item[Integrity:]{property of guarding against improper information modification or destruction, and in-
		cludes ensuring information non-repudiation and authenticity}
	\item[Availability:]{property of ensuring timely and reliable access to and use of information}
	\item[Threat:]{A potential for violation of security, which exists when
		there is an entity, circumstance, capability, action, or event that could cause harm.}
	\item[Vulnerability:]{weakness in an information system, system security procedures, internal controls, or
		implementation that could be exploited by a threat source;}
	\item[Attack]{any kind of malicious activity that attempts to collect, disrupt, deny, degrade, or destroy
		information system resources or the information itself. A successful attack can be also called
		exploit}
	\item[Attacker]{a party who attacks a host, network, or other IT resource.}
\end{description}
One aspect that has to be clarified is that the word exploit and attack refer to two different situations:
\begin{itemize}
	\item{An exploit indicates a successful security violation }
	\item{An attack indicates an attempt at a security violation, but not its result}
\end{itemize}
\newpage

\subsection{SSO}
Single sign-on (SSO) is a property of access control (authorization) applied to two or more independent software applications or systems allowing users to log in with one unique set of credential and have access to all services available on said platforms. This approach allows for users an easier and more relaxed experience given the fact that the issue of inserting credentials many times and their management is not necessary anymore.

The idea just briefly explained will surely make you soon realize that many advantages arises with this, even for the inexperienced user and when considering security:
\begin{itemize}
	\item{risks mitigation for 3rd-party sites }
	\item{reduction of password fatigue from different IDs and passwords}
	\item{cost decrease due to IDs or passwords reset requests}
\end{itemize} 

Procedures and basic structures are needed for this method of authentication, one is obviously some entity entitled to the administration of the every credential of each consumer. The key role for this identity provider in this access control implementation is that every time an authentication is issued, the claimer is redirected to the provider which will check whether the assertion is genuine or not. Another needed feature is session management: this is a procedure which allows a steady usage and interaction between the user and the service, which is vital for every transaction (each having a specific identifier).

Different solutions are available to the public, one is OpenID, an OAuth extension which allow the underlying protocol to handle authentication besides authorization, and SSO Saml, an open standard based on XML markup language.

\subsection{OAuth 2.0}
Oauth 2.0\cite{oauth2} is a delegation framework which allows a third-party application to obtain a limited access to a private resource using the HTTP protocol, either after the authorization of the resource owner or allowing the application to acquire it on its own behalf.

For a clear explanation of this authorization flow we can use as example Google Docs, a service provided by Google which lets two or more users to share and modify online various types of documents. A typical scenario in which OAuth is used is when a web service, or a mobile application, needs access to a document or media file on the Google Docs service shared between multiple accounts. When the application requires this resource, the user is redirected directly to the Google Account server to verify the owner identity. If the authentication is successful, Google Account provides the resource owner an authorization code, which will given to the application and exchanged for an access token that will allow access to the resource.
This simple authentication flow is shown in figure \ref{fig:authcodeflow}.
\newpage

\begin{figure}
	\VerbatimInput{authcodeflow.txt}
	\caption{Authorization code Flow \cite{RFC6749}}
	\label{fig:authcodeflow}
\end{figure}

To have a thorough explanation of the standard, we will define the terminology as in \cite{RFC6749} to define specific roles in the OAuth standard:\\
\begin{description}
	\item[Resource Owner (RO) :]{An entity capable of granting access to a protected resource. When the resource owner is a person, it is referred to as an end-user.}
	\item[Resource Server (RS) :]{The server hosting the protected resources, capable of accepting
		and responding to protected resource requests using access tokens.}
	\item[Client :]{An application making protected resource requests on behalf of the
		resource owner and with its authorization.  The term "client" does
		not imply any particular implementation characteristics (e.g.,
		whether the application executes on a server, a desktop, or other
		devices).
	There are 2 type, differentiated by the ability to authenticate securely with AS:\begin{enumerate}
		\item{\textit{public client: }Clients incapable of maintaining the confidentiality of their
			credentials}
		\item{\textit{confidential client:} Clients capable of maintaining the confidentiality of their
			credentials}
	\end{enumerate}
	}
	\item[Authorization Server (AS) :]{The server issuing authorization codes/access tokens to the client after successfully
		authenticating the resource owner and obtaining authorization.}
\end{description}\newpage
With regards to protocol specification \cite{RFC6749}, we define the following parameters:\\
\begin{description}
	\item[Access Token :]{ Access tokens are credentials used to access protected resources.  An
		access token is a string representing an authorization issued to the
		client.  The string is usually opaque to the client.  Tokens
		represent specific scopes and durations of access, granted by the
		resource owner, and enforced by the resource server and authorization
		server.}
	\item[Refresh Token : ]{Refresh tokens are credentials used to obtain access tokens.  Refresh
		tokens are issued to the client by the authorization server and are
		used to obtain a new access token when the current access token
		becomes invalid or expires, or to obtain additional access tokens
		with identical or narrower scope (access tokens may have a shorter
		lifetime and fewer permissions than authorized by the resource
		owner).}
	\item[Authorization Code : ]{a bearer credential issued to the client that can be exchanged for an access token.}
	\item[client\_id : ]{identification code that identifies a client assigned during registration.}
	\item[Redirect URI : ]{URI used to redirect the user to the client when authentication phase succeeds. This value must be set at client registration time.}
	\item[State : ]{a random generated nonce used by the client to keep a state between a request and a response.}
\end{description}

\subsubsection{OAuth grant types}\label{oauthgranttype}
An authorization grant is the way which the Client gains access to the resource (in other word how C obtains the access token), more particularly on which credentials uses.

OAuth 2.0 defines 4 types of grant which has different level of security and trust for each role and parameters used. Obviously anyone can create new grant types with new extensions.

The four major grants are:
\begin{description}
	\item[Authorization code :]{The authorization code is obtained by using an authorization server
		as an intermediary between the client and resource owner.  Instead of requesting authorization directly from the resource owner, the client directs the resource owner to an authorization server (via its user-agent), which in turn directs the resource owner back to the client with the authorization code that can be later exchanged for a valid access token.}
	\item[Implicit : ]{An access token is directly issued instead of an authorization code, improving performance, but with new security concerns.}
	\item[Resource Owner password Credentials : ]{ RO's credentials are used directly to obtain an access token. This grant should be used only when there is a high degree of true between RO and C.}
	\item[Client Credentials : ]{this grant type is used when the client is acting on its own behalf (C and RO is the same entity) or C is requesting access to a previously granted resource.}
\end{description}
On the time of writing, the first grant type described is the one most used because of its security options and the possibility of separating C and RO.\newpage
\subsubsection{PKCE Extension}
If OAuth is used with no encryption( usually TLS/SSL is an undergoing encryption layer), the authorization phase between RO and AS can be intercepted, which will lead to a sniffed authentication code and a replay attack with an attacker capable of obtaining a valid access token and RO's private data.

This vulnerability can be mitigated with an OAuth extension called \textbf{PKCE} (Proof Key for Code Exchange), defined in RFC 7636\cite{RFC7636}, which uses 3 parameters \textit{code\_verifier}, \textit{code\_challenge} and \textit{code\_challenge\_method}.

PKCE uses an unique randomly generated value(code\_verifier) which is encrypted into a value called code\_challenge using a security proofed hash function indicated with code\_challenge\_method.

This extension does not change the usual authorization code flow, but instead adds these values to specific requests in the grant type to avoid replay attack. More precisely, code\_challenge and code\_challenge\_method values are included when C requests for an authorization code to the AS and code\_verifier is included when the authorization code is exchanged for an access token.

With all these values, the server can prove that the entity requesting the authorization code is the same exact one that used it to request an access token, given the security provided by the hash function.

An example of this abstract flow can be find in figure \ref*{fig:pkceflow}.
\begin{figure}
\VerbatimInput{pkce.txt}
\caption{PKCE abstract protocol flow \cite{RFC7636}}
\label{fig:pkceflow}
\end{figure}
\subsection{OpenID}
As described before, there is distinct difference between authorization and authentication and, for now, we described a protocol which only authorize an entity the use of a resource. AS in the OAuth protocol has sometimes been used also as identity provider to avoid including other protocols. This methodology can lead to vulnerabilities called \textit{code substitution attack}: an attacker can create a malicious application acting as a valid one and request the victim to login and obtain a valid authorization code to exchange it for an access token. 

OpenID\cite{openid} has been developed to solve this problem. It is a OAuth extension which enriches the capability of the protocol giving the opportunity to add an extra layer on top of the it which handles authentication. This is managed by introducing a new entity called \textbf{Identity Provider} (ID) that handles both the registration and authentication process and \textbf{Relying Parties} (RP) which are the applications in need of authentication and "rely" on IDs capabilities to identify or not genuine users.

This extension is much similar to OAuth both for its features and for its logging process. It does not use a central authority (which would be bottle-neck for the entire process) and the use of a single set of credential can guarantee access to multiple services.

\subsubsection{Json Web Token}
The success of this standard is also due to the fact that is can be easily applied to many type of services, may them be web application or even mobile applications and it is possible because the used core technologies are adaptable and modular.

An example of this idea are \textbf{Json Web Tokens}\cite{RFC7515jwt} (JWT), an identity token which encodes multiple user information inside a quite compact string. This is made possible by packaging all the needed details inside three separated \textit{JSONs}: the first one (header) indicates what type of encryption function is used (hash function), the second (payload) asserts the user information and the last of is the digest (\textit{signature}) of the hash function of the second JSON, including a nonce to ensure security.

This three strings are encoded into a base 64 URL-safe string, for ease of use and read, and separated by a dot. An example of a JWT can found in table \ref{table:JWTexample}. The most common parameters in the payload can be found in table \ref{table:JWTparameters}.

The use of a single string can deliver an incredible possibility to the application: the authenticated user can simply send his / hers jwt to asserts his / hers identity and the application can verify by simple calculating the verify signature. If they match the user is genuine, and if they do not match, the user who sent the request is not who is declaring.

\def\arraystretch{1.3}
\newcolumntype{L}[1]{>{\raggedright\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}
\newcolumntype{C}[1]{>{\centering\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}
\newcolumntype{R}[1]{>{\raggedleft\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}
\begin{table}[h]
	\begin{tabularx}{\textwidth}{c}
		\hline
		\textbf{Plain text content} \\
		\hline
	\textbf{Header: }	{
			"alg": "HS256",
			"typ": "JWT"
		} \\
\textbf{Payload: }	{
		"sub": "1234567890",
		"name": "John Doe",
		"iat": 1516239022
	} \\
\textbf{Verify Signature: }\\
HMACSHA256(
base64UrlEncode(header) + "." +
base64UrlEncode(payload),
your-256-bit-secret
)\\
\hline
\\
\hline
\textbf{JWT}\\
\hline
\multicolumn{1}{C{\textwidth}}{eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.\newline eyJzdWIiOiIxMjM0NTY3ODkwIiwibmFtZSI6IkpvaG4gRG9lIiwiaWF0IjoxNTE2MjM5MDIyfQ.\newline
	SflKxwRJSMeKKF2QT4fwpMeJf36POk6yJV\_adQssw5c}\\
\hline
\end{tabularx}
\caption{JWT example}
\label{table:JWTexample}
\end{table}

\begin{table}[h]
\begin{tabularx}{\textwidth}{L{4cm}C{13cm}}
	\hline
	\textbf{Parameter} & \textbf{Value} \\
	\hline
	\textbf{sub}& asserts identity of the user (subject)\\
	\textbf{iss}& indicates the authority who issued the jwt (issuer)\\
	\textbf{aud}& created for a specific client (audience)\\
	\textbf{nonce}& may contain a nonce\\
	\textbf{auth\_time}& specifies when the user authenticated\\
	\textbf{exp\_time}& indicates when the jwt expires\\
	\textbf{iat}&indicated who was issued at\\
	\textbf{name / email adress}&additional information about the user\\
	\hline
\end{tabularx}
	\caption{Information encapsulated inside a JWT}
	\label{table:JWTparameters}
\end{table}
\clearpage